-- Define Contants
a = 0
b = 0
c = 0
d = 0
xpm = 0

-- Define Pos
pos = 1

-- Load Colors
white = Color.new(255, 255, 255)
black = Color.new(0, 0, 0)
blue = Color.new(0, 0, 255)

-- Load Axis
axis = Image.createEmpty(201, 201)
axis:fillRect(0, 0, 201, 201, black)
axis:drawLine(101, 0, 101, 201, white)
axis:drawLine(0, 101, 201, 101, white)

-- Load Graph
graph = Image.createEmpty(201, 201)


-- Define drawRect()
function drawRect(where, x, y, width, height, color)
	where:drawLine(x, y, x+width, y, color)
	where:drawLine(x+width, y, x+width, y+height, color)
	where:drawLine(x+width, y+height, x, y+height, color)
	where:drawLine(x, y+height, x, y, color)
end

--Define GraphClear()
function graphclear()
	screen:blit(140, 35, graph)
	graph:clear()
	graph:fillRect(0, 0, 100, 100, black)
	graph:fillRect(102, 0, 99, 99, black)
	graph:fillRect(0, 102, 100, 99, black)
	graph:fillRect(102, 102, 99, 99, black)
end

-- Define round()
function round(num)
	if (num-math.floor(num))<0.5 then
		math.floor(num)
	else
		math.ciel(num)
	end
end


-- Load  Eq
eq = Image.createEmpty(480, 30)

-- Define ClearEq()
function cleareq()
	eq:clear()
	eq:fillRect(0, 0, 480, 30, black)
	eq:print(80, 0, "y = " .. tostring(a) .. "(x+".. tostring(xpm) .. ")x^3+" .. tostring(b) .. "(x+" .. tostring(xpm) .. ")^2+" .. tostring(c) .. "(x+" .. tostring(xpm) .. ")+" .. tostring(d), white)
	keypad:clear(black)
	keypad:fillRect(0, 0, 148, 22, black)
	apad:print(3, 7, "a", white)
	bpad:print(3, 7, "b", white)
	cpad:print(3, 7, "c", white)
	dpad:print(3, 7, "d", white)
	xpad:print(3, 7, "x", white)
	keypad:blit(1, 1, apad)
	keypad:blit(33, 1, bpad)
	keypad:blit(65, 1, cpad)
	keypad:blit(97, 1, dpad)
	keypad:blit(129, 1, xpad)
	screen:blit(160, 5, keypad)
	resel()
	screen:blit(0, 242, eq)
	screen:flip()
end

-- Define Grapher()
function grapher()             
	x = -101
	while x<102 do
		y = a*((x+xpm)*(x+xpm)*(x+xpm))+b*((x+xpm)*(x+xpm))+c*(x+xpm)+d
		y1 = a*((x+xpm+1)*(x+xpm+1)*(x+xpm+1))+b*((x+xpm+1)*(x+xpm+1))+c*(x+xpm+1)+d
		graph:drawLine(x+101, -y+105, x+101, -y1+105, white)
		x = x+1
	end
	drawRect(graph, 0, 0, 201, 201, black)
	screen:blit(140, 35, axis)
	screen:blit(140, 35, graph)
	screen:flip()
end

-- Load pads
apad = Image.createEmpty(32, 22)
bpad = Image.createEmpty(32, 22)
cpad = Image.createEmpty(32, 22)
dpad = Image.createEmpty(32, 22)
xpad = Image.createEmpty(32, 22)
apad:print(3, 7, "a", white)
bpad:print(3, 7, "b", white)
cpad:print(3, 7, "c", white)
dpad:print(3, 7, "d", white)
xpad:print(3, 7, "x", white)

-- Load Keypad
keypad = Image.createEmpty(160, 22)
keypad:fillRect(0, 0, 148, 22, black)
keypad:blit(1, 1, apad)
keypad:blit(33, 1, bpad)
keypad:blit(65, 1, cpad)
keypad:blit(97, 1, dpad)
keypad:blit(129, 1, xpad)

-- Load keysel
keysel = Image.createEmpty(146, 20)

-- Define resel()
function resel()
	keysel:clear()
	screen:blit(160, 5, keypad)
	

	if pos==1 then
		drawRect(keysel, 0, 0, 32, 22, blue)
	elseif pos==2 then
		drawRect(keysel, 32, 0, 32, 22, blue)
	elseif pos==3 then
		drawRect(keysel, 64, 0, 32, 22, blue)
	elseif pos==4 then
		drawRect(keysel, 96, 0, 32, 22, blue)
	elseif pos==5 then
		drawRect(keysel, 128, 0, 32, 22, blue)
	end
	eq:clear()
	eq:fillRect(0, 0, 480, 30, black)
	eq:print(80, 0, "y = " .. tostring(a) .. "(x+".. tostring(xpm) .. ")^3+" .. tostring(b) .. "(x+" .. tostring(xpm) .. ")^2+" .. tostring(c) .. "(x+" .. tostring(xpm) .. ")+" .. tostring(d), white)
	screen:blit(0, 242, eq)
	screen:blit(140, 35, axis)
	screen:blit(140, 35, graph)
	screen:blit(161, 6, keysel)
	screen:flip()
end

screen:blit(140, 35, axis)
screen:blit(140, 35, graph)
eq:print(80, 0, "y = " .. tostring(a) .. "(x+".. tostring(xpm) .. ")^3+" .. tostring(b) .. "(x+" .. tostring(xpm) .. ")^2+" .. tostring(c) .. "(x+" .. tostring(xpm) .. ")+" .. tostring(d), white)
screen:blit(160, 5, keypad)
screen:blit(161, 6, keysel)
screen:blit(0, 242, eq)
drawRect(keysel, 0, 0, 32, 22, blue)
screen:flip()

while true do

	screen.waitVblankStart(5)
	
	pad = Controls.read()

	if pad:l() then
		if pos==1 then
			pos = 5
		else
			pos = pos-1
		end
		resel()
	elseif pad:r() then
		if pos==5 then
			pos = 1
		else
			pos = pos+1
		end	
		resel()
	elseif pad:up() then
		if pos==1 then
			a = a+1
			cleareq()
		elseif pos==2 then
			b = b+1
			cleareq()
		elseif pos==3 then
			c = c+1
			cleareq()
		elseif pos==4 then
			d = d+1
			cleareq()
		elseif pos==5 then
			xpm = xpm+1
			cleareq()
		end
	elseif pad:down() then
		if pos==1 then
			a = a-1
			cleareq()
		elseif pos==2 then
			b = b-1
			cleareq()
		elseif pos==3 then
			c = c-1
			cleareq()
		elseif pos==4 then
			d = d-1
			cleareq()
		elseif pos==5 then
			xpm = xpm-1
			cleareq()
		end
	elseif pad:right() then
		if pos==1 then
			a = a+0.05
			cleareq()
		elseif pos==2 then
			b = b+0.05
			cleareq()
		elseif pos==3 then
			c = c+0.05
			cleareq()
		elseif pos==4 then
			d = d+0.05
			cleareq()
		elseif pos==5 then
			xpm = xpm+0.05
			cleareq()
		end
	elseif pad:left() then
		if pos==1 then
			a = a-0.05
			cleareq()
		elseif pos==2 then
			b = b-0.05
			cleareq()
		elseif pos==3 then
			c = c-0.05
			cleareq()
		elseif pos==4 then
			d = d-0.05
			cleareq()
		elseif pos==5 then
			xpm = xpm-0.05
			cleareq()
		end
	elseif pad:start() then
		grapher()
	elseif pad:select() then
		screen:save("screenshot.tga")
	elseif pad:triangle() then
		a = 0
		b = 0
		c = 0
		d = 0
		xpm = 0
		cleareq()
	elseif pad:square() then
		graphclear()
		screen:flip()
	end
end
		